]> asedeno.scripts.mit.edu Git - git.git/blob - git-rebase--interactive.sh
rebase -i: Change function make_squash_message into update_squash_message
[git.git] / git-rebase--interactive.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2006 Johannes E. Schindelin
4
5 # SHORT DESCRIPTION
6 #
7 # This script makes it easy to fix up commits in the middle of a series,
8 # and rearrange commits.
9 #
10 # The original idea comes from Eric W. Biederman, in
11 # http://article.gmane.org/gmane.comp.version-control.git/22407
12
13 OPTIONS_KEEPDASHDASH=
14 OPTIONS_SPEC="\
15 git-rebase [-i] [options] [--] <upstream> [<branch>]
16 git-rebase [-i] (--continue | --abort | --skip)
17 --
18  Available options are
19 v,verbose          display a diffstat of what changed upstream
20 onto=              rebase onto given branch instead of upstream
21 p,preserve-merges  try to recreate merges instead of ignoring them
22 s,strategy=        use the given merge strategy
23 m,merge            always used (no-op)
24 i,interactive      always used (no-op)
25  Actions:
26 continue           continue rebasing process
27 abort              abort rebasing process and restore original branch
28 skip               skip current patch and continue rebasing process
29 no-verify          override pre-rebase hook from stopping the operation
30 root               rebase all reachable commmits up to the root(s)
31 "
32
33 . git-sh-setup
34 require_work_tree
35
36 DOTEST="$GIT_DIR/rebase-merge"
37
38 # The file containing rebase commands, comments, and empty lines.
39 # This file is created by "git rebase -i" then edited by the user.  As
40 # the lines are processed, they are removed from the front of this
41 # file and written to the tail of $DONE.
42 TODO="$DOTEST"/git-rebase-todo
43
44 # The rebase command lines that have already been processed.  A line
45 # is moved here when it is first handled, before any associated user
46 # actions.
47 DONE="$DOTEST"/done
48
49 # The commit message that is planned to be used for any changes that
50 # need to be committed following a user interaction.
51 MSG="$DOTEST"/message
52
53 # The file into which is accumulated the suggested commit message for
54 # squash/fixup commands.  When the first of a series of squash/fixups
55 # is seen, the file is created and the commit message from the
56 # previous commit and from the first squash/fixup commit are written
57 # to it.  The commit message for each subsequent squash/fixup commit
58 # is appended to the file as it is processed.
59 #
60 # The first line of the file is of the form
61 #     # This is a combination of $COUNT commits.
62 # where $COUNT is the number of commits whose messages have been
63 # written to the file so far (including the initial "pick" commit).
64 # Each time that a commit message is processed, this line is read and
65 # updated.  It is deleted just before the combined commit is made.
66 SQUASH_MSG="$DOTEST"/message-squash
67
68 # $REWRITTEN is the name of a directory containing files for each
69 # commit that is reachable by at least one merge base of $HEAD and
70 # $UPSTREAM. They are not necessarily rewritten, but their children
71 # might be.  This ensures that commits on merged, but otherwise
72 # unrelated side branches are left alone. (Think "X" in the man page's
73 # example.)
74 REWRITTEN="$DOTEST"/rewritten
75
76 DROPPED="$DOTEST"/dropped
77
78 # A script to set the GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
79 # GIT_AUTHOR_DATE that will be used for the commit that is currently
80 # being rebased.
81 AUTHOR_SCRIPT="$DOTEST"/author-script
82
83 # When an "edit" rebase command is being processed, the SHA1 of the
84 # commit to be edited is recorded in this file.  When "git rebase
85 # --continue" is executed, if there are any staged changes then they
86 # will be amended to the HEAD commit, but only provided the HEAD
87 # commit is still the commit to be edited.  When any other rebase
88 # command is processed, this file is deleted.
89 AMEND="$DOTEST"/amend
90
91 PRESERVE_MERGES=
92 STRATEGY=
93 ONTO=
94 VERBOSE=
95 OK_TO_SKIP_PRE_REBASE=
96 REBASE_ROOT=
97
98 GIT_CHERRY_PICK_HELP="  After resolving the conflicts,
99 mark the corrected paths with 'git add <paths>', and
100 run 'git rebase --continue'"
101 export GIT_CHERRY_PICK_HELP
102
103 warn () {
104         echo "$*" >&2
105 }
106
107 output () {
108         case "$VERBOSE" in
109         '')
110                 output=$("$@" 2>&1 )
111                 status=$?
112                 test $status != 0 && printf "%s\n" "$output"
113                 return $status
114                 ;;
115         *)
116                 "$@"
117                 ;;
118         esac
119 }
120
121 # Output the commit message for the specified commit.
122 commit_message () {
123         git cat-file commit "$1" | sed "1,/^$/d"
124 }
125
126 run_pre_rebase_hook () {
127         if test -z "$OK_TO_SKIP_PRE_REBASE" &&
128            test -x "$GIT_DIR/hooks/pre-rebase"
129         then
130                 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} || {
131                         echo >&2 "The pre-rebase hook refused to rebase."
132                         exit 1
133                 }
134         fi
135 }
136
137 require_clean_work_tree () {
138         # test if working tree is dirty
139         git rev-parse --verify HEAD > /dev/null &&
140         git update-index --ignore-submodules --refresh &&
141         git diff-files --quiet --ignore-submodules &&
142         git diff-index --cached --quiet HEAD --ignore-submodules -- ||
143         die "Working tree is dirty"
144 }
145
146 ORIG_REFLOG_ACTION="$GIT_REFLOG_ACTION"
147
148 comment_for_reflog () {
149         case "$ORIG_REFLOG_ACTION" in
150         ''|rebase*)
151                 GIT_REFLOG_ACTION="rebase -i ($1)"
152                 export GIT_REFLOG_ACTION
153                 ;;
154         esac
155 }
156
157 last_count=
158 mark_action_done () {
159         sed -e 1q < "$TODO" >> "$DONE"
160         sed -e 1d < "$TODO" >> "$TODO".new
161         mv -f "$TODO".new "$TODO"
162         count=$(sane_grep -c '^[^#]' < "$DONE")
163         total=$(($count+$(sane_grep -c '^[^#]' < "$TODO")))
164         if test "$last_count" != "$count"
165         then
166                 last_count=$count
167                 printf "Rebasing (%d/%d)\r" $count $total
168                 test -z "$VERBOSE" || echo
169         fi
170 }
171
172 make_patch () {
173         sha1_and_parents="$(git rev-list --parents -1 "$1")"
174         case "$sha1_and_parents" in
175         ?*' '?*' '?*)
176                 git diff --cc $sha1_and_parents
177                 ;;
178         ?*' '?*)
179                 git diff-tree -p "$1^!"
180                 ;;
181         *)
182                 echo "Root commit"
183                 ;;
184         esac > "$DOTEST"/patch
185         test -f "$MSG" ||
186                 commit_message "$1" > "$MSG"
187         test -f "$AUTHOR_SCRIPT" ||
188                 get_author_ident_from_commit "$1" > "$AUTHOR_SCRIPT"
189 }
190
191 die_with_patch () {
192         make_patch "$1"
193         git rerere
194         die "$2"
195 }
196
197 die_abort () {
198         rm -rf "$DOTEST"
199         die "$1"
200 }
201
202 has_action () {
203         sane_grep '^[^#]' "$1" >/dev/null
204 }
205
206 # Run command with GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
207 # GIT_AUTHOR_DATE exported from the current environment.
208 do_with_author () {
209         GIT_AUTHOR_NAME="$GIT_AUTHOR_NAME" \
210         GIT_AUTHOR_EMAIL="$GIT_AUTHOR_EMAIL" \
211         GIT_AUTHOR_DATE="$GIT_AUTHOR_DATE" \
212         "$@"
213 }
214
215 pick_one () {
216         no_ff=
217         case "$1" in -n) sha1=$2; no_ff=t ;; *) sha1=$1 ;; esac
218         output git rev-parse --verify $sha1 || die "Invalid commit name: $sha1"
219         test -d "$REWRITTEN" &&
220                 pick_one_preserving_merges "$@" && return
221         if test -n "$REBASE_ROOT"
222         then
223                 output git cherry-pick "$@"
224                 return
225         fi
226         parent_sha1=$(git rev-parse --verify $sha1^) ||
227                 die "Could not get the parent of $sha1"
228         current_sha1=$(git rev-parse --verify HEAD)
229         if test -z "$no_ff" -a "$current_sha1" = "$parent_sha1"
230         then
231                 output git reset --hard $sha1
232                 output warn Fast-forward to $(git rev-parse --short $sha1)
233         else
234                 output git cherry-pick "$@"
235         fi
236 }
237
238 pick_one_preserving_merges () {
239         fast_forward=t
240         case "$1" in
241         -n)
242                 fast_forward=f
243                 sha1=$2
244                 ;;
245         *)
246                 sha1=$1
247                 ;;
248         esac
249         sha1=$(git rev-parse $sha1)
250
251         if test -f "$DOTEST"/current-commit
252         then
253                 if test "$fast_forward" = t
254                 then
255                         cat "$DOTEST"/current-commit | while read current_commit
256                         do
257                                 git rev-parse HEAD > "$REWRITTEN"/$current_commit
258                         done
259                         rm "$DOTEST"/current-commit ||
260                         die "Cannot write current commit's replacement sha1"
261                 fi
262         fi
263
264         echo $sha1 >> "$DOTEST"/current-commit
265
266         # rewrite parents; if none were rewritten, we can fast-forward.
267         new_parents=
268         pend=" $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)"
269         if test "$pend" = " "
270         then
271                 pend=" root"
272         fi
273         while [ "$pend" != "" ]
274         do
275                 p=$(expr "$pend" : ' \([^ ]*\)')
276                 pend="${pend# $p}"
277
278                 if test -f "$REWRITTEN"/$p
279                 then
280                         new_p=$(cat "$REWRITTEN"/$p)
281
282                         # If the todo reordered commits, and our parent is marked for
283                         # rewriting, but hasn't been gotten to yet, assume the user meant to
284                         # drop it on top of the current HEAD
285                         if test -z "$new_p"
286                         then
287                                 new_p=$(git rev-parse HEAD)
288                         fi
289
290                         test $p != $new_p && fast_forward=f
291                         case "$new_parents" in
292                         *$new_p*)
293                                 ;; # do nothing; that parent is already there
294                         *)
295                                 new_parents="$new_parents $new_p"
296                                 ;;
297                         esac
298                 else
299                         if test -f "$DROPPED"/$p
300                         then
301                                 fast_forward=f
302                                 replacement="$(cat "$DROPPED"/$p)"
303                                 test -z "$replacement" && replacement=root
304                                 pend=" $replacement$pend"
305                         else
306                                 new_parents="$new_parents $p"
307                         fi
308                 fi
309         done
310         case $fast_forward in
311         t)
312                 output warn "Fast-forward to $sha1"
313                 output git reset --hard $sha1 ||
314                         die "Cannot fast-forward to $sha1"
315                 ;;
316         f)
317                 first_parent=$(expr "$new_parents" : ' \([^ ]*\)')
318
319                 if [ "$1" != "-n" ]
320                 then
321                         # detach HEAD to current parent
322                         output git checkout $first_parent 2> /dev/null ||
323                                 die "Cannot move HEAD to $first_parent"
324                 fi
325
326                 case "$new_parents" in
327                 ' '*' '*)
328                         test "a$1" = a-n && die "Refusing to squash a merge: $sha1"
329
330                         # redo merge
331                         author_script=$(get_author_ident_from_commit $sha1)
332                         eval "$author_script"
333                         msg="$(commit_message $sha1)"
334                         # No point in merging the first parent, that's HEAD
335                         new_parents=${new_parents# $first_parent}
336                         if ! do_with_author output \
337                                 git merge $STRATEGY -m "$msg" $new_parents
338                         then
339                                 printf "%s\n" "$msg" > "$GIT_DIR"/MERGE_MSG
340                                 die_with_patch $sha1 "Error redoing merge $sha1"
341                         fi
342                         ;;
343                 *)
344                         output git cherry-pick "$@" ||
345                                 die_with_patch $sha1 "Could not pick $sha1"
346                         ;;
347                 esac
348                 ;;
349         esac
350 }
351
352 nth_string () {
353         case "$1" in
354         *1[0-9]|*[04-9]) echo "$1"th;;
355         *1) echo "$1"st;;
356         *2) echo "$1"nd;;
357         *3) echo "$1"rd;;
358         esac
359 }
360
361 update_squash_message () {
362         if test -f "$SQUASH_MSG"; then
363                 mv "$SQUASH_MSG" "$SQUASH_MSG".bak || exit
364                 COUNT=$(($(sed -n \
365                         -e "1s/^# This is a combination of \(.*\) commits\./\1/p" \
366                         -e "q" < "$SQUASH_MSG".bak)+1))
367                 {
368                         echo "# This is a combination of $COUNT commits."
369                         sed -e 1d -e '2,/^./{
370                                 /^$/d
371                         }' <"$SQUASH_MSG".bak
372                 } >$SQUASH_MSG
373         else
374                 COUNT=2
375                 {
376                         echo "# This is a combination of 2 commits."
377                         echo "# The first commit's message is:"
378                         echo
379                         commit_message HEAD
380                 } >$SQUASH_MSG
381         fi
382         case $1 in
383         squash)
384                 echo
385                 echo "# This is the $(nth_string $COUNT) commit message:"
386                 echo
387                 commit_message $2
388                 ;;
389         fixup)
390                 echo
391                 echo "# The $(nth_string $COUNT) commit message will be skipped:"
392                 echo
393                 commit_message $2 | sed -e 's/^/#       /'
394                 ;;
395         esac >>$SQUASH_MSG
396 }
397
398 peek_next_command () {
399         sed -n -e "/^#/d" -e "/^$/d" -e "s/ .*//p" -e "q" < "$TODO"
400 }
401
402 do_next () {
403         rm -f "$MSG" "$AUTHOR_SCRIPT" "$AMEND" || exit
404         read command sha1 rest < "$TODO"
405         case "$command" in
406         '#'*|''|noop)
407                 mark_action_done
408                 ;;
409         pick|p)
410                 comment_for_reflog pick
411
412                 mark_action_done
413                 pick_one $sha1 ||
414                         die_with_patch $sha1 "Could not apply $sha1... $rest"
415                 ;;
416         reword|r)
417                 comment_for_reflog reword
418
419                 mark_action_done
420                 pick_one $sha1 ||
421                         die_with_patch $sha1 "Could not apply $sha1... $rest"
422                 git commit --amend
423                 ;;
424         edit|e)
425                 comment_for_reflog edit
426
427                 mark_action_done
428                 pick_one $sha1 ||
429                         die_with_patch $sha1 "Could not apply $sha1... $rest"
430                 make_patch $sha1
431                 git rev-parse --verify HEAD > "$AMEND"
432                 warn "Stopped at $sha1... $rest"
433                 warn "You can amend the commit now, with"
434                 warn
435                 warn "  git commit --amend"
436                 warn
437                 warn "Once you are satisfied with your changes, run"
438                 warn
439                 warn "  git rebase --continue"
440                 warn
441                 exit 0
442                 ;;
443         squash|s|fixup|f)
444                 case "$command" in
445                 squash|s)
446                         squash_style=squash
447                         ;;
448                 fixup|f)
449                         squash_style=fixup
450                         ;;
451                 esac
452                 comment_for_reflog $squash_style
453
454                 test -f "$DONE" && has_action "$DONE" ||
455                         die "Cannot '$squash_style' without a previous commit"
456
457                 mark_action_done
458                 update_squash_message $squash_style $sha1
459                 failed=f
460                 author_script=$(get_author_ident_from_commit HEAD)
461                 echo "$author_script" > "$AUTHOR_SCRIPT"
462                 eval "$author_script"
463                 output git reset --soft HEAD^
464                 pick_one -n $sha1 || failed=t
465                 case "$(peek_next_command)" in
466                 squash|s|fixup|f)
467                         USE_OUTPUT=output
468                         cp "$SQUASH_MSG" "$MSG" || exit
469                         MSG_OPT=-F
470                         EDIT_OR_FILE="$MSG"
471                         ;;
472                 *)
473                         USE_OUTPUT=
474                         MSG_OPT=
475                         EDIT_OR_FILE=-e
476                         cp "$SQUASH_MSG" "$MSG" || exit
477                         mv "$SQUASH_MSG" "$GIT_DIR"/SQUASH_MSG || exit
478                         rm -f "$GIT_DIR"/MERGE_MSG || exit
479                         ;;
480                 esac
481                 if test $failed = f
482                 then
483                         # This is like --amend, but with a different message
484                         do_with_author $USE_OUTPUT git commit --no-verify \
485                                 $MSG_OPT "$EDIT_OR_FILE" ||
486                                 failed=t
487                 fi
488                 if test $failed = t
489                 then
490                         cp "$MSG" "$GIT_DIR"/MERGE_MSG
491                         warn
492                         warn "Could not apply $sha1... $rest"
493                         die_with_patch $sha1 ""
494                 fi
495                 ;;
496         *)
497                 warn "Unknown command: $command $sha1 $rest"
498                 if git rev-parse --verify -q "$sha1" >/dev/null
499                 then
500                         die_with_patch $sha1 "Please fix this in the file $TODO."
501                 else
502                         die "Please fix this in the file $TODO."
503                 fi
504                 ;;
505         esac
506         test -s "$TODO" && return
507
508         comment_for_reflog finish &&
509         HEADNAME=$(cat "$DOTEST"/head-name) &&
510         OLDHEAD=$(cat "$DOTEST"/head) &&
511         SHORTONTO=$(git rev-parse --short $(cat "$DOTEST"/onto)) &&
512         NEWHEAD=$(git rev-parse HEAD) &&
513         case $HEADNAME in
514         refs/*)
515                 message="$GIT_REFLOG_ACTION: $HEADNAME onto $SHORTONTO" &&
516                 git update-ref -m "$message" $HEADNAME $NEWHEAD $OLDHEAD &&
517                 git symbolic-ref HEAD $HEADNAME
518                 ;;
519         esac && {
520                 test ! -f "$DOTEST"/verbose ||
521                         git diff-tree --stat $(cat "$DOTEST"/head)..HEAD
522         } &&
523         rm -rf "$DOTEST" &&
524         git gc --auto &&
525         warn "Successfully rebased and updated $HEADNAME."
526
527         exit
528 }
529
530 do_rest () {
531         while :
532         do
533                 do_next
534         done
535 }
536
537 # skip picking commits whose parents are unchanged
538 skip_unnecessary_picks () {
539         fd=3
540         while read command sha1 rest
541         do
542                 # fd=3 means we skip the command
543                 case "$fd,$command,$(git rev-parse --verify --quiet $sha1^)" in
544                 3,pick,"$ONTO"*|3,p,"$ONTO"*)
545                         # pick a commit whose parent is current $ONTO -> skip
546                         ONTO=$sha1
547                         ;;
548                 3,#*|3,,*)
549                         # copy comments
550                         ;;
551                 *)
552                         fd=1
553                         ;;
554                 esac
555                 echo "$command${sha1:+ }$sha1${rest:+ }$rest" >&$fd
556         done <"$TODO" >"$TODO.new" 3>>"$DONE" &&
557         mv -f "$TODO".new "$TODO" ||
558         die "Could not skip unnecessary pick commands"
559 }
560
561 # check if no other options are set
562 is_standalone () {
563         test $# -eq 2 -a "$2" = '--' &&
564         test -z "$ONTO" &&
565         test -z "$PRESERVE_MERGES" &&
566         test -z "$STRATEGY" &&
567         test -z "$VERBOSE"
568 }
569
570 get_saved_options () {
571         test -d "$REWRITTEN" && PRESERVE_MERGES=t
572         test -f "$DOTEST"/strategy && STRATEGY="$(cat "$DOTEST"/strategy)"
573         test -f "$DOTEST"/verbose && VERBOSE=t
574         test -f "$DOTEST"/rebase-root && REBASE_ROOT=t
575 }
576
577 while test $# != 0
578 do
579         case "$1" in
580         --no-verify)
581                 OK_TO_SKIP_PRE_REBASE=yes
582                 ;;
583         --verify)
584                 ;;
585         --continue)
586                 is_standalone "$@" || usage
587                 get_saved_options
588                 comment_for_reflog continue
589
590                 test -d "$DOTEST" || die "No interactive rebase running"
591
592                 # Sanity check
593                 git rev-parse --verify HEAD >/dev/null ||
594                         die "Cannot read HEAD"
595                 git update-index --ignore-submodules --refresh &&
596                         git diff-files --quiet --ignore-submodules ||
597                         die "Working tree is dirty"
598
599                 # do we have anything to commit?
600                 if git diff-index --cached --quiet --ignore-submodules HEAD --
601                 then
602                         : Nothing to commit -- skip this
603                 else
604                         . "$AUTHOR_SCRIPT" ||
605                                 die "Cannot find the author identity"
606                         amend=
607                         if test -f "$AMEND"
608                         then
609                                 amend=$(git rev-parse --verify HEAD)
610                                 test "$amend" = $(cat "$AMEND") ||
611                                 die "\
612 You have uncommitted changes in your working tree. Please, commit them
613 first and then run 'git rebase --continue' again."
614                                 git reset --soft HEAD^ ||
615                                 die "Cannot rewind the HEAD"
616                         fi
617                         do_with_author git commit --no-verify -F "$MSG" -e || {
618                                 test -n "$amend" && git reset --soft $amend
619                                 die "Could not commit staged changes."
620                         }
621                 fi
622
623                 require_clean_work_tree
624                 do_rest
625                 ;;
626         --abort)
627                 is_standalone "$@" || usage
628                 get_saved_options
629                 comment_for_reflog abort
630
631                 git rerere clear
632                 test -d "$DOTEST" || die "No interactive rebase running"
633
634                 HEADNAME=$(cat "$DOTEST"/head-name)
635                 HEAD=$(cat "$DOTEST"/head)
636                 case $HEADNAME in
637                 refs/*)
638                         git symbolic-ref HEAD $HEADNAME
639                         ;;
640                 esac &&
641                 output git reset --hard $HEAD &&
642                 rm -rf "$DOTEST"
643                 exit
644                 ;;
645         --skip)
646                 is_standalone "$@" || usage
647                 get_saved_options
648                 comment_for_reflog skip
649
650                 git rerere clear
651                 test -d "$DOTEST" || die "No interactive rebase running"
652
653                 output git reset --hard && do_rest
654                 ;;
655         -s)
656                 case "$#,$1" in
657                 *,*=*)
658                         STRATEGY="-s "$(expr "z$1" : 'z-[^=]*=\(.*\)') ;;
659                 1,*)
660                         usage ;;
661                 *)
662                         STRATEGY="-s $2"
663                         shift ;;
664                 esac
665                 ;;
666         -m)
667                 # we use merge anyway
668                 ;;
669         -v)
670                 VERBOSE=t
671                 ;;
672         -p)
673                 PRESERVE_MERGES=t
674                 ;;
675         -i)
676                 # yeah, we know
677                 ;;
678         --root)
679                 REBASE_ROOT=t
680                 ;;
681         --onto)
682                 shift
683                 ONTO=$(git rev-parse --verify "$1") ||
684                         die "Does not point to a valid commit: $1"
685                 ;;
686         --)
687                 shift
688                 test -z "$REBASE_ROOT" -a $# -ge 1 -a $# -le 2 ||
689                 test ! -z "$REBASE_ROOT" -a $# -le 1 || usage
690                 test -d "$DOTEST" &&
691                         die "Interactive rebase already started"
692
693                 git var GIT_COMMITTER_IDENT >/dev/null ||
694                         die "You need to set your committer info first"
695
696                 if test -z "$REBASE_ROOT"
697                 then
698                         UPSTREAM_ARG="$1"
699                         UPSTREAM=$(git rev-parse --verify "$1") || die "Invalid base"
700                         test -z "$ONTO" && ONTO=$UPSTREAM
701                         shift
702                 else
703                         UPSTREAM=
704                         UPSTREAM_ARG=--root
705                         test -z "$ONTO" &&
706                                 die "You must specify --onto when using --root"
707                 fi
708                 run_pre_rebase_hook "$UPSTREAM_ARG" "$@"
709
710                 comment_for_reflog start
711
712                 require_clean_work_tree
713
714                 if test ! -z "$1"
715                 then
716                         output git show-ref --verify --quiet "refs/heads/$1" ||
717                                 die "Invalid branchname: $1"
718                         output git checkout "$1" ||
719                                 die "Could not checkout $1"
720                 fi
721
722                 HEAD=$(git rev-parse --verify HEAD) || die "No HEAD?"
723                 mkdir "$DOTEST" || die "Could not create temporary $DOTEST"
724
725                 : > "$DOTEST"/interactive || die "Could not mark as interactive"
726                 git symbolic-ref HEAD > "$DOTEST"/head-name 2> /dev/null ||
727                         echo "detached HEAD" > "$DOTEST"/head-name
728
729                 echo $HEAD > "$DOTEST"/head
730                 case "$REBASE_ROOT" in
731                 '')
732                         rm -f "$DOTEST"/rebase-root ;;
733                 *)
734                         : >"$DOTEST"/rebase-root ;;
735                 esac
736                 echo $ONTO > "$DOTEST"/onto
737                 test -z "$STRATEGY" || echo "$STRATEGY" > "$DOTEST"/strategy
738                 test t = "$VERBOSE" && : > "$DOTEST"/verbose
739                 if test t = "$PRESERVE_MERGES"
740                 then
741                         if test -z "$REBASE_ROOT"
742                         then
743                                 mkdir "$REWRITTEN" &&
744                                 for c in $(git merge-base --all $HEAD $UPSTREAM)
745                                 do
746                                         echo $ONTO > "$REWRITTEN"/$c ||
747                                                 die "Could not init rewritten commits"
748                                 done
749                         else
750                                 mkdir "$REWRITTEN" &&
751                                 echo $ONTO > "$REWRITTEN"/root ||
752                                         die "Could not init rewritten commits"
753                         fi
754                         # No cherry-pick because our first pass is to determine
755                         # parents to rewrite and skipping dropped commits would
756                         # prematurely end our probe
757                         MERGES_OPTION=
758                         first_after_upstream="$(git rev-list --reverse --first-parent $UPSTREAM..$HEAD | head -n 1)"
759                 else
760                         MERGES_OPTION="--no-merges --cherry-pick"
761                 fi
762
763                 SHORTHEAD=$(git rev-parse --short $HEAD)
764                 SHORTONTO=$(git rev-parse --short $ONTO)
765                 if test -z "$REBASE_ROOT"
766                         # this is now equivalent to ! -z "$UPSTREAM"
767                 then
768                         SHORTUPSTREAM=$(git rev-parse --short $UPSTREAM)
769                         REVISIONS=$UPSTREAM...$HEAD
770                         SHORTREVISIONS=$SHORTUPSTREAM..$SHORTHEAD
771                 else
772                         REVISIONS=$ONTO...$HEAD
773                         SHORTREVISIONS=$SHORTHEAD
774                 fi
775                 git rev-list $MERGES_OPTION --pretty=oneline --abbrev-commit \
776                         --abbrev=7 --reverse --left-right --topo-order \
777                         $REVISIONS | \
778                         sed -n "s/^>//p" | while read shortsha1 rest
779                 do
780                         if test t != "$PRESERVE_MERGES"
781                         then
782                                 echo "pick $shortsha1 $rest" >> "$TODO"
783                         else
784                                 sha1=$(git rev-parse $shortsha1)
785                                 if test -z "$REBASE_ROOT"
786                                 then
787                                         preserve=t
788                                         for p in $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)
789                                         do
790                                                 if test -f "$REWRITTEN"/$p -a \( $p != $ONTO -o $sha1 = $first_after_upstream \)
791                                                 then
792                                                         preserve=f
793                                                 fi
794                                         done
795                                 else
796                                         preserve=f
797                                 fi
798                                 if test f = "$preserve"
799                                 then
800                                         touch "$REWRITTEN"/$sha1
801                                         echo "pick $shortsha1 $rest" >> "$TODO"
802                                 fi
803                         fi
804                 done
805
806                 # Watch for commits that been dropped by --cherry-pick
807                 if test t = "$PRESERVE_MERGES"
808                 then
809                         mkdir "$DROPPED"
810                         # Save all non-cherry-picked changes
811                         git rev-list $REVISIONS --left-right --cherry-pick | \
812                                 sed -n "s/^>//p" > "$DOTEST"/not-cherry-picks
813                         # Now all commits and note which ones are missing in
814                         # not-cherry-picks and hence being dropped
815                         git rev-list $REVISIONS |
816                         while read rev
817                         do
818                                 if test -f "$REWRITTEN"/$rev -a "$(sane_grep "$rev" "$DOTEST"/not-cherry-picks)" = ""
819                                 then
820                                         # Use -f2 because if rev-list is telling us this commit is
821                                         # not worthwhile, we don't want to track its multiple heads,
822                                         # just the history of its first-parent for others that will
823                                         # be rebasing on top of it
824                                         git rev-list --parents -1 $rev | cut -d' ' -s -f2 > "$DROPPED"/$rev
825                                         short=$(git rev-list -1 --abbrev-commit --abbrev=7 $rev)
826                                         sane_grep -v "^[a-z][a-z]* $short" <"$TODO" > "${TODO}2" ; mv "${TODO}2" "$TODO"
827                                         rm "$REWRITTEN"/$rev
828                                 fi
829                         done
830                 fi
831
832                 test -s "$TODO" || echo noop >> "$TODO"
833                 cat >> "$TODO" << EOF
834
835 # Rebase $SHORTREVISIONS onto $SHORTONTO
836 #
837 # Commands:
838 #  p, pick = use commit
839 #  r, reword = use commit, but edit the commit message
840 #  e, edit = use commit, but stop for amending
841 #  s, squash = use commit, but meld into previous commit
842 #  f, fixup = like "squash", but discard this commit's log message
843 #
844 # If you remove a line here THAT COMMIT WILL BE LOST.
845 # However, if you remove everything, the rebase will be aborted.
846 #
847 EOF
848
849                 has_action "$TODO" ||
850                         die_abort "Nothing to do"
851
852                 cp "$TODO" "$TODO".backup
853                 git_editor "$TODO" ||
854                         die "Could not execute editor"
855
856                 has_action "$TODO" ||
857                         die_abort "Nothing to do"
858
859                 test -d "$REWRITTEN" || skip_unnecessary_picks
860
861                 git update-ref ORIG_HEAD $HEAD
862                 output git checkout $ONTO && do_rest
863                 ;;
864         esac
865         shift
866 done